﻿-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

--[[local f = CreateFrame("Frame",nil,UIParent)
f:SetFrameStrata("BACKGROUND")
f:SetWidth(64) -- Set these to whatever height/width is needed 
f:SetHeight(64) -- for your Texture

local t = f:CreateTexture(nil,"BACKGROUND")
t:SetTexture("Interface\\ICONS\\ability_monk_jab.blp")
t:SetAllPoints(f)
f.texture = t

f:SetPoint("CENTER",0,0)
f:Show()]]


local lastUpdate=0
cfg.Update=nil
cfg.UpdateDOT=nil
local p
local spname,startTime,endTime

local phealth,phealthmax,ppower,ppowermax,ppactiveRegen,pshape
local function EnumerateTooltipLines_helper(...)
    for i = 1, select("#", ...) do
        local region = select(i, ...)
        if region and region:GetObjectType() == "FontString" then
            local text = region:GetText() -- string or nil
			text = text or " "
			print(region:GetName().." "..text)
        end
    end
end

function EnumerateTooltipLines(tooltip) -- good for script handlers that pass the tooltip as the first argument.
    EnumerateTooltipLines_helper(tooltip:GetRegions())
end

function Hedd_test(spell)
--[[	local numTabs = GetNumTalentTabs();
for t=1, numTabs do
    DEFAULT_CHAT_FRAME:AddMessage(GetTalentTabInfo(t)..":");
    local numTalents = GetNumTalents(t);
    for i=1, numTalents do
        nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(t,i);
        DEFAULT_CHAT_FRAME:AddMessage("- "..nameTalent..": "..currRank.."/"..maxRank);
    end
end]]
	
	local Hedd_Tooltip = _G["Hedd_Tooltip"] or CreateFrame('GameTooltip', 'Hedd_Tooltip', UIParent, 'GameTooltipTemplate')
	-- call this every time you want to scan
	Hedd_Tooltip:SetOwner(UIParent, 'ANCHOR_NONE')
	-- do something with the tooltip, for example set it to a player buff   
--	Hedd_Tooltip:SetUnitBuff('player', 1)
	Hedd_Tooltip:SetSpellByID(spell)
	EnumerateTooltipLines(Hedd_Tooltip)
	for i=1,Hedd_Tooltip:NumLines() do
		local mytext=_G["Hedd_TooltipTextLeft"..i]
		local text=mytext:GetText()
		print(i.." "..text)
	end
	
	
-- get information from the tooltip, for example the buff description
	local text=Hedd_TooltipTextLeft2:GetText()
	print (lib.tofloat(text))
 
-- finally hide it again
	Hedd_Tooltip:Hide()
	return text

--[[	local f = CreateFrame("Frame",nil,UIParent)
	f:SetFrameStrata("BACKGROUND")
	f:SetWidth(64) -- Set these to whatever height/width is needed 
	f:SetHeight(64) -- for your Texture

	local t = f:CreateTexture(nil,"BACKGROUND")
	--t:SetTexture("Interface\\Icons\\Ability_Shaman_Stormstrike")
	t:SetTexture(GetSpellTexture(115356))
	t:SetAllPoints(f)
	f.texture = t
	
	f:SetPoint("CENTER",0,0)
	f:Show()]]
end

function Hedd_test2(spell)
	print(lib.Hedd_GSI(spell))
	print(GetSpellCooldown(spell))
	print(IsUsableSpell(spell))
end

local function Hedd_findclass()
	cfg.talenttree = GetSpecialization() or 4 --GetPrimarycfg.talenttree()
	if lib.classes[cfg.class] and lib.classes[cfg.class][cfg.talenttree] then
		cfg.classfound=true
		return lib.classes[cfg.class][cfg.talenttree]()
	end
	cfg.classfound=nil
	return false
end

lib.basicevents = function()
		
--[[	function Heddevents.ACTIONBAR_SHOW_BOTTOMLEFT(...)
		print(...)
	end]]
	
	function Heddevents.UNIT_POWER_FREQUENT(unit,powerType)
		if unit=="player" then
			lib.UpdatePower(powerType)
		end
	end
	
	function Heddevents.UNIT_HEALTH_FREQUENT(unit)
		if unit=="target" then
			lib.UpdateHealth()
		end
	end
	
	Heddevents.ACTIONBAR_UPDATE_COOLDOWN=lib.UpdateAllSpells
	Heddevents.ACTIONBAR_SLOT_CHANGED=lib.UpdateAllSpells
	Heddevents.SPELL_ACTIVATION_OVERLAY_GLOW_SHOW=lib.UpdateAllSpells
	Heddevents.ACTIONBAR_UPDATE_STATE=lib.UpdateAllSpells
	Heddevents.ACTIONBAR_UPDATE_USABLE=lib.UpdateAllSpells
	Heddevents.SPELL_UPDATE_USABLE=lib.UpdateAllSpells
	Heddevents.SPELL_UPDATE_COOLDOWN=lib.UpdateAllSpells
	
	function Heddevents.UNIT_AURA(unitID)
		if cfg.watchunits[unitID] and UnitExists(unitID) then
			lib.UpdateAuraAll(unitID)
			if unitID=="player" then
				lib.UpdateAllSpells()
				lib.UpdatePower()
			end
		end
	end
	
	function Heddevents.PLAYER_TARGET_CHANGED()
		lib.ResetCast()
		Heddevents.UNIT_AURA("target")
		lib.instance()
		lib.UpdateTarget()
		lib.ComboUpdate()
		Heddevents.UNIT_HEALTH_FREQUENT("target")
		cfg.Update=true
	end

	function Heddevents.PLAYER_REGEN_ENABLED()
		lib.ResetCast()
		cfg.Update=true
	end
	
	function Heddevents.PLAYER_EQUIPMENT_CHANGED(slot, hasItem)
		lib.UpdateEquip(slot)
		lib.UpdateSet()
		cfg.Update=true
	end

	function Heddevents.UNIT_SPELLCAST_START(u, spellname, rank, castid, spellID)
		if u=="player" then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_START "..spellname) end
			lib.UpdateCastStart(u)
			lib.SwitchMode()
			lib.UpdatePower(cfg.powertype)
			cfg.Update=true
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_FAILED(u, spellname, rank, castid, spellID)
		if u=="player" then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_FAILED "..spellname) end
			lib.UpdatePower(cfg.powertype)
			if cfg.castid~=castid then return end
			lib.UpdateCastStop()
			lib.UpdatePower(cfg.powertype)
			cfg.Update=true
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_INTERRUPTED(u, spellname, rank, castid, spellID)
		if u=="player" then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_INTERRUPTED "..spellname) end
			if cfg.castid~=castid then return end
			lib.UpdateCastStop()
			lib.UpdatePower(cfg.powertype)
			cfg.Update=true
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_DELAYED(u, spellname, rank, castid, spellID)
		if u=="player" then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_DELAYED "..spellname) end
			lib.UpdateCastStart(u)
			lib.SwitchMode()
			lib.UpdatePower(cfg.powertype)
			cfg.Update=true
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_STOP(u, spellname, rank, castid, spellID)
		if u=="player" then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_STOP "..spellname) end
			if cfg.castid~=castid then return end
			lib.UpdateCastStop()
			lib.UpdatePower(cfg.powertype)
			cfg.Update=true
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_SUCCEEDED(u, spellname, rank, castid, spellID)
		if u=="player" and not cfg.res_spells[spellname] then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_SUCCEEDED "..spellname.." "..spellID) end
			lib.UpdateSpellCD(cfg.id2spell[spellID],true)
			if cfg.ischanneling and cfg.showchannel then
				Heddevents.UNIT_SPELLCAST_CHANNEL_START(u,spellname)
			else
				lib.UpdateCast(u)
				lib.SaveSpell(spellID)
				lib.SwitchMode()
				lib.UpdatePower(cfg.powertype)
				cfg.Update=true
			end
		end
	end
	--[[function Heddevents.UNIT_SPELLCAST_SUCCEEDED(u, spellname, rank, lineID, spellID)
		print (u..","..spellname..","..rank..","..lineID..","..spellID)
	end]]

	function Heddevents.UNIT_SPELLCAST_CHANNEL_START(u, spellname, rank, castid, spellID)
		if u=="player" and cfg.showchannel then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_CHANNEL_START "..spellname) end
			spname, _, _, _, startTime, endTime = UnitChannelInfo(u)
			if not spname then return end
			cfg.ischanneling=true
			cfg.casting=spname
			cfg.castStart=startTime / 1e3
			cfg.castEnd=endTime / 1e3
			lib.SwitchMode()
			cfg.Update=true
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_CHANNEL_UPDATE(u, spellname, rank, castid, spellID)
		if u=="player" and cfg.showchannel then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_CHANNEL_UPDATE "..spellname) end
			spname, _, _, _, startTime, endTime = UnitChannelInfo(u)
			if not spname then return end
			cfg.ischanneling=true
			cfg.casting=spname
			cfg.castStart=startTime / 1e3
			cfg.castEnd=endTime / 1e3
			lib.SwitchMode()
			cfg.Update=true
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_CHANNEL_STOP(u, spellname, rank, castid, spellID)
		if u=="player" and cfg.showchannel then
			if cfg.debugspells then print(cfg.now.." UNIT_SPELLCAST_CHANNEL_STOP "..spellname) end
			cfg.ischanneling=nil
			cfg.casting=nil
			cfg.castEnd=cfg.now
			lib.SaveSpell(spellID)
			lib.SwitchMode()
			cfg.Update=true
		end
	end
	
	function Heddevents.COMBAT_LOG_EVENT_UNFILTERED(timeStamp, eventtype,_,sourceGUID,sourceName,_,_,destGUID,destName,_,_,spellId,spellName,_,_,interrupt)
	if cfg.TrackDOT then
		if eventtype == "SPELL_AURA_APPLIED" or eventtype == "SPELL_AURA_REFRESH" or eventtype == "SPELL_PERIODIC_DAMAGE" or eventtype == "SPELL_PERIODIC_HEAL" then
			if spellId == cfg.auras[cfg.TrackDOT].id then
				if sourceGUID == cfg.pguid then
					lib.AddDOT(destGUID)
				end
			end
		end
		if eventtype == "SPELL_AURA_REMOVED" then
			if spellId == cfg.auras[cfg.TrackDOT].id then
				if sourceGUID == cfg.pguid then
					lib.DelDOT(destGUID)
				end
			end
		end
		if eventtype == "UNIT_DIED" or eventtype == "UNIT_DESTROYED"  then
			lib.DelDOT(destGUID)
		end
	end
	if sourceGUID == cfg.pguid then
		if eventtype == "SPELL_CAST_SUCCESS" then
			if cfg.debugspells then print(cfg.now.." CL(SPELL_CAST_SUCCESS) "..spellName) end
			--print(cfg.now.." "..spellName.." "..spellId)
			spell = lib.SpellId2Spell(spellId)
			if spell then 
				cfg.spells[spell].guid=destGUID
				cfg.spells[spell].lastcast=cfg.now
			end
		end
	end
end


--[[	function Heddevents.UPDATE_SHAPESHIFT_FORM(...)
		pshape=cfg.shape
		cfg.shape=lib.shape()
		
		if cfg.shape~=pshape then
			if lib.onshapeupdate then lib.onshapeupdate() end
			cfg.Update=true
		end
	end]]
	
	function Heddevents.PLAYER_ENTERING_WORLD()
		lib.UpdateAllSpells()
		Heddevents.PLAYER_TARGET_CHANGED()
		Heddevents.UNIT_AURA("player")
		Heddevents.UNIT_POWER_FREQUENT("player")
		lib.UpdateShape()
--		lib.instance()
		cfg.Update=true
	end
	
	--[[function Heddevents.UPDATE_SHAPESHIFT_FORM()
		lib.UpdateShape()
	end]]
end

local function Hedd_onupdate(self, elapsed)
	cfg.lastUpdate = cfg.lastUpdate + elapsed
	cfg.now = GetTime()
	if lib.myonupdate then lib.myonupdate() end
	if lib.rangecheck then lib.rangecheck() end
	if cfg.Update 
--	or cfg.lastUpdate > cfg.UpdateTime 
	or (cfg.nextUpdate>0 and cfg.nextUpdate<=cfg.now)
--	or 	(cfg.now>=cfg.nextUpdate and ((cfg.lastnextUpdate and not cfg.nextUpdate==cfg.lastnextUpdate) or not cfg.lastnextUpdate))
	then --or lib.SpellCasting()
--		if cfg.now>=cfg.nextUpdate then cfg.lastnextUpdate=cfg.nextUpdate end
		
		if cfg.TrackBUFF then lib.UpdateBUFF() end
		-- if cfg.Update then  end
		lib.SetPriority()
		Heddframe.text:SetText(cfg.mode)
		cfg.lastUpdate = 0
		cfg.Update=nil
		cfg.nextUpdate=lib.GetSpellCDNext()
	end
end

function Heddtal_onevent(self,event)
	for index,name in pairs(cfg.spells) do
		lib.HideFrame(cfg.spells[index].f)
	end
	Heddframe.text:Hide()
	Heddframe:Hide()
	lib.defaults()
	
	Heddframe:UnregisterAllEvents()
	Heddframe:SetScript("OnEvent",nil)
	Heddframe:SetScript("OnUpdate",nil)
	if Hedd_findclass() then
		lib.basicevents()
		if lib.classevents[cfg.class] then lib.classevents[cfg.class]() end
		lib.UpdateShape()
		if lib.mytal then lib.mytal() end
		
		cfg.case["end"] = function ()
			if cfg.cmintime~=cfg.maxmintime then return nil end
			return lib.SimpleCDCheck("aa")
		end
		
		lib.UpdateEquipAll()
	
		cfg.numcase=0
		for key, value in pairs(cfg.plist) do
			cfg.numcase=cfg.numcase+1
		end
		cfg.numcase=cfg.numcase+1
		
		Heddframe:SetScript("OnEvent", function(self, event, ...)
			if not cfg.classfound then return end
			cfg.now=GetTime()
			if Heddevents[event] then Heddevents[event](...) end
			if Heddclassevents[event] then Heddclassevents[event](...) end
			
		end)

		for k, v in pairs(Heddevents) do
			Heddframe:RegisterEvent(k)
		end
		
		for k, v in pairs(Heddclassevents) do
			Heddframe:RegisterEvent(k)
		end
		
		Heddframe:SetScript("OnUpdate", Hedd_onupdate)
		
		if cfg.TrackDOT then
			Heddframe.DOT:SetScript("OnUpdate", lib.OnUpdateDOT)
			Heddframe.DOT:Show()
		else
			Heddframe.DOT:SetScript("OnUpdate", nil)
			Heddframe.DOT:Hide()
		end

		Heddevents.PLAYER_ENTERING_WORLD()
		Heddframe:Show()
		Heddframe.text:Show()
		
	end
	
end

cfg.notloaded=true
local function Heddframe_pew(self,...)
--	print(...)
	if not GetSpellInfo(GetSpellInfo(6603)) then return nil end
	if not GetInventorySlotInfo("MainHandSlot") then
		return nil
	end
	
--[[	if GetItemIcon(GetInventoryItemID("player",16))~=select(3,GetSpellInfo(6603)) then
		return nil
	end]]
	
	
	if cfg.notloaded then
		
		cfg.notloaded=nil
		Heddframe:UnregisterAllEvents()
		Heddframe:SetScript("OnUpdate",nil)
		Heddframe:RegisterForClicks("AnyUp")
		Heddframe:SetScript("OnClick", function (self, button, down)
		if lib.onclick then lib.onclick() end
		end);

		Heddtalents:SetScript("OnEvent",Heddtal_onevent)
		Heddtalents:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
		Heddtalents:RegisterEvent("CHARACTER_POINTS_CHANGED")
		Heddtalents:SetScript("OnUpdate",function(...) 
		if UnitOnTaxi("player") or C_PetBattles.IsInBattle() then Heddframe:Hide()
		else Heddframe:Show() end
		end)
		--Heddtalents:RegisterEvent("PLAYER_TALENT_UPDATE")
		--Heddtalents:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
		--Heddtalents:RegisterEvent("SPELLS_CHANGED")
		Heddtal_onevent()
		-- Hedd_test()
	end
end

--hooksecurefunc("TalentFrame_Update",function(...) print("TalentFrame_Update") end)
Heddframe:SetScript("OnEvent",Heddframe_pew)
Heddframe:SetScript("OnUpdate",Heddframe_pew)
--Heddframe:RegisterEvent("SPELLS_CHANGED")
--Heddframe:RegisterEvent("PLAYER_TALENT_UPDATE")
Heddframe:RegisterEvent("PLAYER_ENTERING_WORLD")
